"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAuthenticatedHandler = exports.hasRoleHandler = exports.hasPermissionHandler = void 0;
const getDecodedToken_1 = require("./utils/getDecodedToken");
exports.hasPermissionHandler = (ctx, permissions) => {
    var _a;
    const decoded = getDecodedToken_1.getDecodedToken(ctx);
    const decodedPermissions = ((_a = decoded) === null || _a === void 0 ? void 0 : _a.permissions) || [];
    if (permissions.length === 0)
        return;
    if (!permissions.some(p => decodedPermissions.find(dp => dp === p))) {
        throw new Error(`Insufficient permissions. Missing one of these: ${permissions.join(", ")}`);
    }
};
exports.hasRoleHandler = (ctx, roles) => {
    var _a;
    const decoded = getDecodedToken_1.getDecodedToken(ctx);
    const decodedRoles = ((_a = decoded) === null || _a === void 0 ? void 0 : _a.roles) || [];
    if (roles.length === 0)
        return;
    if (!roles.some(p => decodedRoles.find(dp => dp === p))) {
        throw new Error(`Insufficient roles. Missing one of these: ${roles.join(", ")}`);
    }
};
exports.isAuthenticatedHandler = (ctx) => {
    getDecodedToken_1.getDecodedToken(ctx);
};
