"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.authTypeDefs = exports.createAuthDirectives = void 0;
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const hasPermission_1 = __importDefault(require("./directives/hasPermission"));
const hasRole_1 = __importDefault(require("./directives/hasRole"));
const isAuthenticated_1 = __importDefault(require("./directives/isAuthenticated"));
const createAuthDirectives = (options) => ({
    hasPermission: hasPermission_1.default(options === null || options === void 0 ? void 0 : options.hasPermissionHandler),
    hasRole: hasRole_1.default(options === null || options === void 0 ? void 0 : options.hasRoleHandler),
    isAuthenticated: isAuthenticated_1.default(options === null || options === void 0 ? void 0 : options.isAuthenticatedHandler),
});
exports.createAuthDirectives = createAuthDirectives;
const authTypeDefs = graphql_tag_1.default `
  directive @isAuthenticated on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
  directive @hasPermission(permissions: [String!]!) on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
  directive @hasRole(roles: [String!]!) on FIELD | FIELD_DEFINITION | INPUT_FIELD_DEFINITION
`;
exports.authTypeDefs = authTypeDefs;
