import { GraphQLField, GraphQLInputField, GraphQLInputObjectType } from "graphql";
import { SchemaDirectiveVisitor } from "graphql-tools";
declare const _default: (overiddeHandler: ((ctx: any, roles: string[]) => void) | undefined) => {
    new (config: {
        name: string;
        args: {
            [name: string]: any;
        };
        visitedType: import("graphql-tools/dist/schemaVisitor").VisitableSchemaType;
        schema: import("graphql").GraphQLSchema;
        context: {
            [key: string]: any;
        };
    }): {
        visitFieldDefinition(field: GraphQLField<any, any>): void;
        visitInputFieldDefinition(field: GraphQLInputField, details: {
            objectType: GraphQLInputObjectType;
        }): void;
        filterInputPred(details: {
            objectType: GraphQLInputObjectType;
        }): (mutation: GraphQLField<any, any, {
            [key: string]: any;
        }>) => import("graphql").GraphQLArgument | undefined;
        name: string;
        args: {
            [name: string]: any;
        };
        visitedType: import("graphql-tools/dist/schemaVisitor").VisitableSchemaType;
        context: {
            [key: string]: any;
        };
        schema: import("graphql").GraphQLSchema;
        visitSchema(schema: import("graphql").GraphQLSchema): void;
        visitScalar(scalar: import("graphql").GraphQLScalarType): void | import("graphql").GraphQLScalarType | null;
        visitObject(object: import("graphql").GraphQLObjectType<any, any, {
            [key: string]: any;
        }>): void | import("graphql").GraphQLObjectType<any, any, {
            [key: string]: any;
        }> | null;
        visitArgumentDefinition(argument: import("graphql").GraphQLArgument, details: {
            field: GraphQLField<any, any, {
                [key: string]: any;
            }>;
            objectType: import("graphql").GraphQLInterfaceType | import("graphql").GraphQLObjectType<any, any, {
                [key: string]: any;
            }>;
        }): void | import("graphql").GraphQLArgument | null;
        visitInterface(iface: import("graphql").GraphQLInterfaceType): void | import("graphql").GraphQLInterfaceType | null;
        visitUnion(union: import("graphql").GraphQLUnionType): void | import("graphql").GraphQLUnionType | null;
        visitEnum(type: import("graphql").GraphQLEnumType): void | import("graphql").GraphQLEnumType | null;
        visitEnumValue(value: import("graphql").GraphQLEnumValue, details: {
            enumType: import("graphql").GraphQLEnumType;
        }): void | import("graphql").GraphQLEnumValue | null;
        visitInputObject(object: GraphQLInputObjectType): void | GraphQLInputObjectType | null;
    };
    getDirectiveDeclaration(directiveName: string, schema: import("graphql").GraphQLSchema): import("graphql").GraphQLDirective;
    visitSchemaDirectives(schema: import("graphql").GraphQLSchema, directiveVisitors: {
        [directiveName: string]: typeof SchemaDirectiveVisitor;
    }, context?: {
        [key: string]: any;
    } | undefined): {
        [directiveName: string]: SchemaDirectiveVisitor[];
    };
    getDeclaredDirectives(schema: import("graphql").GraphQLSchema, directiveVisitors: {
        [directiveName: string]: typeof SchemaDirectiveVisitor;
    }): {
        [directiveName: string]: import("graphql").GraphQLDirective;
    };
    implementsVisitorMethod(methodName: string): boolean;
};
export default _default;
